<template>
  <button
    :class="[
      $style['button'],
      $style[variant],
      isActive ? $style['is-active'] : null,
    ]"
  >
    <slot />
  </button>
</template>

<script lang="ts">
import {
  defineComponent,
} from "@nuxtjs/composition-api";

export default defineComponent({
  props: {
    variant: {
      type: String,
      default: "outlined",
    },
    isActive: {
      type: Boolean,
      default: false,
    },
  },
});
</script>

<style lang="postcss" module>
.button {
  transition:
    background 250ms ease,
    border-color 250ms ease,
    color 250ms ease;
  height: 2.75rem;

  @apply flex justify-between items-center;

  & > span {
    padding-top: 2px;

    @apply inline-block mx-2;
  }

  svg {
    @apply w-5 h-5;
  }

  &:disabled {
    @apply border-gray-200 bg-gray-200 text-gray-400;
  }

  &.outlined {
    @apply border-1 border-blue-700 rounded-none px-3 bg-white text-blue-700 font-semibold;

    &:focus {
      @apply outline-none;
    }

    &:hover,
    &[data-focus-visible-added],
    &.is-active {
      padding: 0 calc(0.75rem - 1px);

      @apply outline-none border-2;
    }
  }

  &.underlined {
    height: 2.5rem;

    @apply border-b-6 p-0 font-semibold;

    &:hover,
    &:focus,
    &.is-active {
      @apply outline-none border-blue-700 text-blue-700;
    }
  }
}
</style>
